diff --git a/OsmAnd-java/build.xml b/OsmAnd-java/build.xml
index c32548ab65..e764b2b09c 100644
--- a/OsmAnd-java/build.xml
+++ b/OsmAnd-java/build.xml
@@ -80,6 +80,12 @@
+
+
+
+
+
+
diff --git a/OsmAnd-java/collect_legacy_libs.sh b/OsmAnd-java/collect_legacy_libs.sh
new file mode 100755
index 0000000000..2d9601c770
--- /dev/null
+++ b/OsmAnd-java/collect_legacy_libs.sh
@@ -0,0 +1,31 @@
+#!/bin/bash
+
+set -e
+
+SCRIPT_LOC="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
+CORE_LOC="$SCRIPT_LOC/../../core"
+
+if [[ "$(uname -a)" =~ Linux ]]; then
+ if [[ -z "$OSMAND_BUILD_CPU_CORES_NUM" ]]; then
+ OSMAND_BUILD_CPU_CORES_NUM=`nproc`
+ fi
+fi
+
+function copyLibs {
+ if [ -d "$CORE_LOC/binaries/$1/$2" ]; then
+ echo "Copy binaries $1 $2";
+ cp "$CORE_LOC"/binaries/$1/$2/Release/libosmand.so bin/osmand-$1-$3.lib
+ fi
+}
+
+function compile {
+ "$CORE_LOC/core/externals/configure.sh"
+ if [ ! -d "$CORE_LOC/targets/amd64-linux-gcc-amd64-linux-gcc-release.baked" ]; then
+ "$CORE_LOC/targets/amd64-linux-gcc.sh" release
+ fi
+ (cd "$CORE_LOC/targets/amd64-linux-gcc-amd64-linux-gcc-release.baked" && make -j$OSMAND_BUILD_CPU_CORES_NUM OsmAndJNI)
+}
+
+compile
+copyLibs linux amd64 amd64 so
+# copyLibs linux i686 x86 so